<i18n>
{
  "fr": {
    "title-1": "Modifier un véhicule",
    "title-2": "Ajouter un véhicule",
    "title-3": "Visualiser un véhicule",
    "info-1": "Sélectionnez le type de véhicule (véhicules routiers, bateaux ou encore aéronefs) ainsi que sa motorisation.",
    "info-2": "Par défaut la saisie des données (consommation d’énergie, distance parcourue, durée d'utilisation) est mensuelle. Si vous avez seulement une donnée annuelle, décochez la case « Consommations / Heures de vol mensuelles disponibles ».",
    "check-1": "Le laboratoire a le contrôle opérationnel de ce véhicule.",
    "tooltip-1": "Le laboratoire a le contrôle opérationnel du véhicule si il le possède, le loue dans le cadre d'un contrat de leasing ou l'exploite. Si le véhicule est mis à disposition par un prestataire extérieur sans que le laboratoire puisse décider du type de véhicule qu'il souhaite, le laboratoire n'en a pas le contrôle opérationel.",
    "field-1": "Heures de vol mensuelles disponibles",
    "field-2": "Distances mensuelles disponibles en",
    "field-3": "Consommations mensuelles disponibles en",
    "field-4": "Heures de vol totales",
    "field-5": "Distance totale en",
    "field-6": "Consommation totale en",
    "field-7": "Puissance totale (en CV)",
    "field-8": "# moteurs",
    "field-9": "Type d'aéronef"
  },
  "en": {
    "title-1": "Update a vehicle",
    "title-2": "Add a vehicle",
    "title-3": "View a vehicle",
    "info-1": "Select the type of vehicle (road vehicle, ship, aircraft) as well as the type of engine.",
    "info-2": "By default, the data entry (energy consumption, distance traveled, duration of use) is per month. If you only have data per year, uncheck the box « Monthly consumption /flight hours available ».",
    "check-1": "The laboratory operationally controls this vehicle",
    "tooltip-1": "The laboratory operationally controls the vehicle if it owns it, leases it or controls its use. If the vehicle is provided by an external company and the laboratory cannot decide which type of vehicle to operate, the laboratory does not operationnally control the vehicle.",
    "field-1": "Monthly flight hours available",
    "field-2": "Monthly distances available in",
    "field-3": "Monthly consumption available in",
    "field-4": "Total flight hours",
    "field-5": "Total distance in",
    "field-6": "Total consumption in",
    "field-7": "Total power (HP)",
    "field-8": "# engines",
    "field-9": "Type of aircraft"
  }
}
</i18n>

<template>
  <b-modal
    :active="displayModal"
    has-modal-card
    @close="closeForm"
    :can-cancel="['escape', 'x', 'outside']"
  >
    <div class="modal-card" style="width: 1000px; height: auto">
      <form @submit.prevent="validateBeforeSubmit">
        <header class="modal-card-head">
          <p class="modal-card-title">{{ modalTitle }}</p>
        </header>
        <section class="modal-card-body">
          <b-notification :closable="false">
            {{ $t('info-1') }}
            <br />
            {{ $t('info-2') }}
          </b-notification>
          <b-notification :closable="false">
            <b-checkbox
              :disabled="submitted"
              v-model="cvehicle.controled"
            >
              {{ $t('check-1') }}
              <b-tooltip multilined :label="$t('tooltip-1')" type="is-info">
                <b-tag rounded type="is-info">
                  <b-icon icon="info"></b-icon>
                </b-tag>
              </b-tooltip>
            </b-checkbox>
          </b-notification>
          <b-notification :closable="false">
            <div class="columns">
              <div class="column">
                <b-field
                  v-if="allVehicles.length === 0"
                  :label="$t('id')"
                  :type="{'is-danger': errors.has('name')}"
                  :message="errors.first('name')">
                  <b-input
                    name="name"
                    :icon="typeIcon()"
                    :icon-pack="typeIconPack()"
                    v-validate="'required|uniqueID'"
                    :disabled="submitted"
                    maxlength="50"
                    v-model="cvehicle.name"
                  ></b-input>
                </b-field>
                <b-field
                  v-else
                  :label="$t('id')"
                  :type="{'is-danger': errors.has('name')}"
                  :message="errors.first('name')">
                  <b-autocomplete
                    :icon="typeIcon()"
                    :icon-pack="typeIconPack()"
                    v-model="cvehicle.name"
                    :open-on-focus="true"
                    v-validate="'required|uniqueID'"
                    :data="allVehicles"
                    field="name"
                    :disabled="submitted"
                    @typing="reset()"
                    @select="option => selectedVehicle(option)">
                  </b-autocomplete>
                </b-field>
              </div>
              <div class="column">
                <b-field
                  :label="$t('type')"
                  :type="{'is-danger': errors.has('type')}"
                  :message="errors.first('type')">
                  <b-select
                    expanded
                    @input="typeChanged"
                    name="type"
                    v-validate="'required'"
                    :disabled="submitted"
                    v-model="cvehicle.type"
                  >
                    <option
                      :value="ctype"
                      v-for="(ctype,index) in types"
                      :key="index"
                    >
                      {{ $t(ctype) }}
                    </option>
                  </b-select>
                </b-field>
              </div>
              <div class="column">
                <b-field
                  :label="labelType"
                  :type="{'is-danger': errors.has('engine')}"
                  :message="errors.first('engine')">
                  <b-select
                    expanded
                    @input="engineChanged"
                    :disabled="engineDisabled || submitted"
                    name="engine"
                    v-model="cvehicle.engine"
                  >
                    <option
                      :value="cengine"
                      v-for="(cengine,index) in engines"
                      :key="index"
                    >
                      {{ $t(cengine) }}
                    </option>
                  </b-select>
                </b-field>
              </div>
              <div class="column" v-if="cvehicle.engine.startsWith('plane')">
                <b-field
                  :label="$t('field-7')"
                  :type="{'is-danger': errors.has('power')}"
                  :message="errors.first('power')">
                  <b-input
                    name="power"
                    v-validate="'required|numeric'"
                    :disabled="submitted"
                    maxlength="50"
                    v-model="cvehicle.power"
                  ></b-input>
                </b-field>
              </div>
              <div class="column" v-if="cvehicle.engine.startsWith('helicopter')">
                <b-field
                  :label="$t('field-8')"
                  :type="{'is-danger': errors.has('noEngine')}"
                  :message="errors.first('noEngine')">
                  <b-select
                    :disabled="cvehicle.engine==='helicopter.pistons' || submitted"
                    expanded
                    name="noEngine"
                    v-validate="'required|numeric'"
                    v-model="cvehicle.noEngine"
                  >
                    <option value="1">1</option>
                    <option value="2">2</option>
                    <option value="3">3</option>
                  </b-select>
                </b-field>
              </div>
              <div class="column" v-if="cvehicle.engine.startsWith('helicopter')">
                <b-field
                  label="Shaft power"
                  :type="{'is-danger': errors.has('shp')}"
                  :message="errors.first('shp')">
                  <b-input
                    name="noEngine"
                    :disabled="submitted"
                    v-validate="'required|numeric'"
                    maxlength="50"
                    v-model="cvehicle.shp"
                  ></b-input>
                </b-field>
              </div>
            </div>
          </b-notification>
          <b-notification :closable="false">
            <consumption-form :disabled="submitted" v-model="cvehicle.consumption">
              <template
                v-if="cvehicle.type==='aircraft'"
                v-slot:mensuelles
              >
                {{ $t('field-1') }}
              </template>
              <template
                v-else-if="vehiclesWithKM.includes(cvehicle.type)"
                v-slot:mensuelles
              >
                {{ $t('field-2') }} {{ $t(cvehicle.unit) }}
              </template>
              <template
                v-else
                v-slot:mensuelles
              >
                {{ $t('field-3') }} {{ $t(cvehicle.unit) }}
              </template>
              <template
                v-if="cvehicle.type==='aircraft'"
                v-slot:totale
              >
                {{ $t('field-4') }}
              </template>
              <template
                v-else-if="vehiclesWithKM.includes(cvehicle.type)"
                v-slot:totale
              >
                {{ $t('field-5') }} {{ $t(cvehicle.unit) }}
              </template>
              <template
                v-else
                v-slot:totale
              >
                {{ $t('field-6') }} {{ $t(cvehicle.unit) }}
              </template>
            </consumption-form>
          </b-notification>
          <hr />
          <nav class="level">
            <div class="level-left"></div>
            <div class="buttons level-right">
              <b-button
                class="button"
                @click="closeForm()"
                icon-left="close"
              >
                {{ $t('cancel') }}
              </b-button>
              <button
                v-show="modeCreation"
                type="submit"
                :disabled="submitted"
                class="button is-primary"
              >
                <span class="icon is-small"><i class="sui sui-plus"></i></span>
                <span> {{ $t('add') }} </span>
              </button>
              <button
                v-show="!modeCreation"
                :disabled="submitted"
                type="submit"
                class="button is-primary"
              >
                <span class="icon is-small"><i class="sui sui-refresh"></i></span>
                <span> {{ $t('update') }} </span>
              </button>
            </div>
          </nav>
        </section>
      </form>
    </div>
  </b-modal>
</template>

<script>
import Vehicle from '@/models/carbon/Vehicle.js'
import { mapGetters } from 'vuex'

const DEFAULT_TYPE = 'car'
const DEFAULT_ENGINE = 'gasoline'
const DEFAULT_UNIT = 'km'
const DEFAULT_NOENGINE = 1

export default {
  name: 'VehicleModal',
  props: {
    displayModal: {
      type: Boolean,
      default: false
    },
    vehicle: {
      type: Object,
      default: function () {
        return {}
      }
    },
    vehicles: {
      type: Array,
      default: function () {
        return []
      }
    },
    modeCreation: {
      type: Boolean,
      default: false
    }
  },
  components: {
    'consumption-form': () => import('@/components/carbon/forms/ConsumptionForm.vue')
  },
  $_veeValidate: {
    validator: 'new'
  },
  data () {
    return {
      cvehicle: Object.assign({}, this.vehicle),
      vehiclesWithKM: ['car', 'motorbike', 'bike', 'scooter']
    }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    allVehicles: function () {
      let usedNames = this.vehicles.map(obj => obj.name)
      return this.$store.getters['admin/allVehicles'].filter(obj => !(usedNames.includes(obj.name)))
    },
    labelType: function () {
      if (this.cvehicle.engine.startsWith('plane')) {
        return this.$t('field-9')
      } else if (this.cvehicle.engine.startsWith('helicopter')) {
        return this.$t('field-9')
      } else {
        return this.$t('engine')
      }
    },
    submitted: function () {
      return this.$store.getters['ghgi/item']['vehiclesSubmitted']
    },
    types: function () {
      return Vehicle.getTypes()
    },
    engines: function () {
      return Vehicle.getEngines(this.cvehicle.type)
    },
    enginesUnits: function () {
      return Vehicle.getUnits(
        this.cvehicle.type,
        this.cvehicle.engine
      )
    },
    engineDisabled: function () {
      return this.engines.length === 1
    },
    modalTitle: function () {
      let title = this.$t('title-1')
      if (this.modeCreation) {
        title = this.$t('title-2')
      } else if (this.submitted) {
        title = this.$t('title-3')
      }
      return title
    }
  },
  methods: {
    typeIcon: function () {
      return Vehicle.getIcon(this.cvehicle.type)
    },
    typeIconPack: function () {
      return Vehicle.getIconPack(this.cvehicle.type)
    },
    validateBeforeSubmit () {
      this.$validator.validateAll().then((result) => {
        if (result) {
          if (this.modeCreation) {
            this.$emit('add', this.cvehicle)
          } else {
            this.$emit(
              'update',
              {
                'from': this.vehicle,
                'to': this.cvehicle
              }
            )
          }
        }
      })
    },
    typeChanged: function () {
      this.cvehicle.engine = this.engines[0]
      this.cvehicle.unit = this.enginesUnits
    },
    engineChanged: function () {
      this.cvehicle.unit = this.enginesUnits
      if (this.cvehicle.engine === 'helicopter.pistons') {
        this.cvehicle.noEngine = 1
      }
    },
    selectedVehicle (vehicle) {
      this.cvehicle.id = vehicle.id
      this.cvehicle.name = vehicle.name
      this.cvehicle.type = vehicle.type
      this.cvehicle.engine = vehicle.engine
      this.cvehicle.unit = vehicle.unit
      this.cvehicle.power = vehicle.power
      this.cvehicle.noEngine = vehicle.noEngine
      this.cvehicle.shp = vehicle.shp
      this.cvehicle.controled = vehicle.controled
    },
    closeForm: function () {
      this.$emit('close')
    },
    reset () {
      this.cvehicle.id = null
      this.cvehicle.name = ''
      this.cvehicle.type = DEFAULT_TYPE
      this.cvehicle.engine = DEFAULT_ENGINE
      this.cvehicle.unit = DEFAULT_UNIT
      this.cvehicle.power = 0
      this.cvehicle.noEngine = DEFAULT_NOENGINE
      this.cvehicle.shp = 0
      this.cvehicle.controled = true
    }
  },
  mounted () {
    if (this.isAuthenticated) {
      const loadingComponent = this.$buefy.loading.open({
        container: null
      })
      this.$store.dispatch('admin/getAllVehicles')
        .then(data => {
          loadingComponent.close()
        })
    }
  },
  created () {
    this.$validator.extend('uniqueID', {
      getMessage: field => 'Identifiant déjà utilisé.',
      validate: (value) => {
        if (!this.modeCreation) {
          if (value === this.cvehicle.name) {
            return true
          } else {
            return this.vehicles.filter(obj => obj.name === value).length === 0
          }
        } else {
          return this.vehicles.filter(obj => obj.name === value).length === 0
        }
      }
    })
  }
}
</script>
